var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React, { useEffect, useState } from 'react';
import defaultValues from "../default/values";
import BattleNetIcon from '../battlenet.svg';
var OAuth2BnetComponent = function (_a) {
    var btnText = _a.btnText, logoStyle = _a.logoStyle, linkStyle = _a.linkStyle, containerStyle = _a.containerStyle, settings = _a.settings, callback = _a.callback, containerClassName = _a.containerClassName, btnClassName = _a.btnClassName, logoClassName = _a.logoClassName;
    var _b = useState(), bnetOAuth2Clinet = _b[0], setBnetOAuth2Clinet = _b[1];
    var BTN_DEFAULT_TEXT = defaultValues.BTN_DEFAULT_TEXT;
    var retrieveUserInfo = function (OAuth2BattleNetClient, code) { return __awaiter(void 0, void 0, void 0, function () {
        var headers, resp, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    headers = new Headers();
                    headers.append("Content-Type", "application/x-www-form-urlencoded");
                    headers.set('Authorization', 'Basic ' + btoa(OAuth2BattleNetClient.getClientId() + ":" + OAuth2BattleNetClient.getClientSecret()));
                    return [4 /*yield*/, fetch("" + OAuth2BattleNetClient.getTokenUri(), {
                            method: "POST",
                            headers: headers,
                            body: "redirect_uri=" + OAuth2BattleNetClient.getRedirectUri() + "&scope=" + OAuth2BattleNetClient.getScopes() + "&grant_type=authorization_code&code=" + code
                        })];
                case 1:
                    resp = _b.sent();
                    if (!(resp.status === 200)) return [3 /*break*/, 3];
                    _a = callback;
                    return [4 /*yield*/, resp.json()];
                case 2:
                    _a.apply(void 0, [_b.sent()]);
                    _b.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    }); };
    useEffect(function () {
        var urlParams = new URLSearchParams((window.location.search)).get("code");
        var OAuth2BattleNetClient = settings;
        setBnetOAuth2Clinet(OAuth2BattleNetClient);
        if (urlParams !== null) {
            retrieveUserInfo(OAuth2BattleNetClient, urlParams);
        }
    }, []);
    return (React.createElement("div", null,
        React.createElement("div", { style: containerStyle, className: containerClassName },
            React.createElement("a", { className: btnClassName, style: linkStyle, href: bnetOAuth2Clinet === null || bnetOAuth2Clinet === void 0 ? void 0 : bnetOAuth2Clinet.getAuthorizeURL() },
                React.createElement("img", { src: BattleNetIcon, className: logoClassName, style: logoStyle, alt: "battle.net logo" }),
                btnText && btnText !== "" ? btnText : BTN_DEFAULT_TEXT))));
};
export default OAuth2BnetComponent;
