declare type RegionName = "eu" | "us" | "apac" | "cn";
declare type Scopes = "wow.profile" | "sc2.profile" | "d3.profile" | "openid";
interface Region {
    getAuthorizationUri(): string;
    getTokenUri(): string;
}
interface OAuth2Settings {
    getScopes(): Array<Scopes>;
    getGrantType(): string;
}
interface OAuth2ApplicationSetting {
    getClientId(): string;
    getClientSecret(): string;
    getRedirectUri(): string;
    getResponseType(): string;
}
export declare class OAuth2CodeFlowConfiguration implements Region, OAuth2Settings, OAuth2ApplicationSetting {
    regionName: RegionName;
    scopes: Array<Scopes>;
    clientId: string;
    clientSecret: string;
    responseType: string;
    redirectUri: string;
    grantType: string;
    private _authorizeUri;
    private _tokenUri;
    constructor({ regionName, scopes, clientId, response_type, redirect_uri, clientSecret }: {
        regionName: RegionName;
        scopes: Array<Scopes>;
        clientId: string;
        response_type: string;
        redirect_uri: string;
        clientSecret: string;
    });
    getGrantType(): string;
    getClientSecret(): string;
    getAuthorizeURL(): string;
    getRedirectUri(): string;
    getResponseType(): string;
    getClientId(): string;
    getTokenUri(): string;
    getScopes(): Scopes[];
    getAuthorizationUri(): string;
}
export {};
