var OAuth2CodeFlowConfiguration = /** @class */ (function () {
    function OAuth2CodeFlowConfiguration(_a) {
        var regionName = _a.regionName, scopes = _a.scopes, clientId = _a.clientId, response_type = _a.response_type, redirect_uri = _a.redirect_uri, clientSecret = _a.clientSecret;
        this.grantType = "authorization_code";
        this.regionName = regionName;
        this.scopes = scopes;
        this.redirectUri = redirect_uri;
        this.responseType = response_type;
        this.clientId = clientId;
        this.clientSecret = clientSecret;
        this._authorizeUri = regionName === "cn" ? "https://www.battlenet.com.cn/oauth/authorize" : "https://" + this.regionName + ".battle.net/oauth/authorize";
        this._tokenUri = regionName === "cn" ? "https://www.battlenet.com.cn/oauth/token" : "https://" + this.regionName + ".battle.net/oauth/token";
    }
    OAuth2CodeFlowConfiguration.prototype.getGrantType = function () {
        return this.grantType;
    };
    OAuth2CodeFlowConfiguration.prototype.getClientSecret = function () {
        return this.clientSecret;
    };
    OAuth2CodeFlowConfiguration.prototype.getAuthorizeURL = function () {
        return this._authorizeUri + "?scope=" + this.scopes.join(" ") + "&client_id=" + this.clientId + "&response_type=" + this.responseType + "&redirect_uri=" + this.redirectUri;
    };
    OAuth2CodeFlowConfiguration.prototype.getRedirectUri = function () {
        return this.redirectUri;
    };
    OAuth2CodeFlowConfiguration.prototype.getResponseType = function () {
        return this.responseType;
    };
    OAuth2CodeFlowConfiguration.prototype.getClientId = function () {
        return this.clientId;
    };
    OAuth2CodeFlowConfiguration.prototype.getTokenUri = function () {
        return this._tokenUri;
    };
    OAuth2CodeFlowConfiguration.prototype.getScopes = function () {
        return this.scopes;
    };
    OAuth2CodeFlowConfiguration.prototype.getAuthorizationUri = function () {
        return this._authorizeUri;
    };
    return OAuth2CodeFlowConfiguration;
}());
export { OAuth2CodeFlowConfiguration };
